#include "aswm/aswm.h"
#include "aswm/event_handlers/create.h"
#include "aswm/event_handlers/configure.h"
#include "aswm/event_handlers/map.h"
#include "aswm/event_handlers/reparent.h"
#include "aswm/event_handlers/destroy.h"

aswm _aswm;

void AswmOpen() {
	_aswm.display = XOpenDisplay(NULL);
	_aswm.root = DefaultRootWindow(_aswm.display);

	XSelectInput(_aswm.display, _aswm.root, SubstructureRedirectMask | SubstructureNotifyMask);
	XSync(_aswm.display, 0);
}

void AswmEventLoop() {
	for (;;) {
		XEvent e;
		XNextEvent(_aswm.display, &e);

		switch(e.type) {
			case CreateNotify:
				OnCreateNotify(&e.xcreatewindow);
				break;
			case ConfigureRequest:
				OnConfigureRequest(&e.xconfigurerequest);
				break;
			case MapRequest:
				OnMapRequest(_aswm.root, &e.xmaprequest);
				break;
			case DestroyNotify:
				OnDestroyNotify(&e.xdestroywindow);
				break;
			case ReparentNotify:
				OnReparentNotify(&e.xreparent);
				break;
			default:
				break;
					/* LOG(WARNING) << "Ignored event"; */
		}
	}
}

void AswmClose() {
	XCloseDisplay(_aswm.display);
}
